import * as tslib_1 from "tslib";
import "../../Core/core.scss";
import "../../Common.scss";
import "./Button.scss";
import * as React from "react";
import { FocusZoneContext } from '../../FocusZone';
import { FabricIcon } from '../../Icon';
import { css } from '../../Util';
var Button = /** @class */ (function (_super) {
    tslib_1.__extends(Button, _super);
    function Button() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onKeyDown = function (event) {
            if (!event.defaultPrevented) {
                if (event.which === 13 /* Enter */ || event.which === 32 /* Space */) {
                    if (_this.props.onClick) {
                        _this.props.onClick(event);
                    }
                    event.preventDefault();
                }
            }
        };
        _this.onMouseDown = function (event) {
            if (!event.defaultPrevented) {
                if (_this.props.disabled) {
                    event.preventDefault();
                }
            }
        };
        return _this;
    }
    Button.prototype.focus = function () {
        if (this._buttonElem) {
            this._buttonElem.focus();
        }
    };
    Button.prototype.render = function () {
        var _this = this;
        return (React.createElement(FocusZoneContext.Consumer, null, function (zoneContext) {
            var ButtonType = _this.props.href ? "a" : "button";
            // Render the button element with all the appropriate properties.
            var button = (React.createElement(ButtonType, { "aria-controls": _this.props.ariaControls, "aria-disabled": _this.props.disabled, "aria-expanded": _this.props.ariaExpanded, "aria-haspopup": _this.props.ariaHasPopup, "aria-label": _this.props.ariaLabel, "aria-setsize": _this.props.ariaSetSize, "aria-posinset": _this.props.ariaPosInSet, className: css(_this.props.className, "bolt-button", _this.props.href && "bolt-link-button", _this.props.iconProps && "bolt-icon-button", _this.props.disabled ? "disabled" : "enabled", _this.props.primary && "primary", _this.props.subtle && "subtle", _this.props.iconProps && !_this.props.text && React.Children.count(_this.props.children) == 0 && "icon-only", "bolt-focus-treatment"), disabled: _this.props.disabled, "data-focuszone": !_this.props.disabled && !_this.props.excludeFocusZone ? zoneContext.focuszoneId : undefined, "data-index": _this.props.dataIndex, href: _this.props.href, id: _this.props.id, onClick: !_this.props.disabled ? _this.props.onClick : undefined, onKeyDown: _this.onKeyDown, onMouseDown: _this.onMouseDown, onFocus: _this.props.onFocus, role: _this.props.role || "button", tabIndex: _this.props.disabled ? -1 : _this.props.tabIndex, type: !_this.props.href ? "button" : undefined, ref: function (elem) { _this._buttonElem = elem; } },
                _this.props.iconProps && FabricIcon(Object.assign({}, _this.props.iconProps, { className: "left-icon" })),
                _this.props.text && React.createElement("span", { className: "bolt-button-text" }, _this.props.text),
                _this.props.children));
            return button;
        }));
    };
    return Button;
}(React.Component));
export { Button };
