import * as tslib_1 from "tslib";
import "../../Core/core.scss";
import "../../Common.scss";
import "./Checkbox.scss";
import * as React from "react";
import { FocusZoneContext } from '../../FocusZone';
import { FabricIcon } from '../../Icon';
import { ObservableLike } from '../../Core/Observable';
import { css } from '../../Util';
var checkboxId = 1;
var Checkbox = /** @class */ (function (_super) {
    tslib_1.__extends(Checkbox, _super);
    function Checkbox(props) {
        var _this = _super.call(this, props) || this;
        _this.onCheckChange = function (checked) {
            _this.forceUpdate();
        };
        _this.onClick = function (event) {
            _this.onChange(event);
        };
        _this.onKeyDown = function (event) {
            if (!event.defaultPrevented) {
                if (event.which === 32 /* Space */ || event.which === 13 /* Enter */) {
                    _this.onChange(event);
                    event.preventDefault();
                }
            }
        };
        _this.onChange = function (event) {
            if (_this.props.onChange) {
                _this.props.onChange(event, !ObservableLike.getValue(_this.props.checked));
            }
        };
        _this._labelId = "checkbox-" + checkboxId++ + "-label";
        return _this;
    }
    Checkbox.prototype.render = function () {
        var _this = this;
        var checked = this.props.checked && ObservableLike.getValue(this.props.checked);
        return (React.createElement(FocusZoneContext.Consumer, null, function (zoneContext) {
            var checkbox = (React.createElement("div", { className: css(_this.props.className, "bolt-checkbox", checked && "checked", _this.props.disabled ? "disabled" : "enabled", "bolt-focus-treatment", _this.props.label && "labelled"), tabIndex: !_this.props.disabled && !_this.props.excludeTabStop ? 0 : undefined, onClick: !_this.props.disabled ? _this.onClick : undefined, "data-focuszone": !_this.props.disabled && !_this.props.excludeFocusZone ? zoneContext.focuszoneId : undefined, onKeyDown: _this.onKeyDown, role: (_this.props.role || "checkbox"), "aria-checked": checked, "aria-label": _this.props.ariaLabel, "aria-labelledby": (_this.props.ariaLabelledBy || _this.props.labelId || (_this.props.label && _this._labelId)) },
                React.createElement("div", { className: css("bolt-checkmark", "flex-row") }, FabricIcon({ iconName: "CheckMark" })),
                _this.props.label && (React.createElement("div", { className: "bolt-checkbox-label", id: _this.props.labelId || _this._labelId }, _this.props.label)),
                _this.props.children));
            if (!_this.props.label) {
                checkbox = (React.createElement("div", { className: "bolt-checkbox-container" }, checkbox));
            }
            return checkbox;
        }));
    };
    Checkbox.prototype.componentDidMount = function () {
        ObservableLike.subscribe(this.props.checked, this.onCheckChange);
    };
    Checkbox.prototype.componentWillUnmount = function () {
        ObservableLike.unsubscribe(this.props.checked, this.onCheckChange);
    };
    return Checkbox;
}(React.Component));
export { Checkbox };
