import * as tslib_1 from "tslib";
import "../../FabricInit";
import * as React from "react";
import { DatePicker } from "office-ui-fabric-react/lib/DatePicker";
import { TextField } from "office-ui-fabric-react/lib/TextField";
import { BaseComponent, warn } from "office-ui-fabric-react/lib/Utilities";
import * as Resources from '../../VSS.Resources.VSSUI';
import "./DateTimePicker.css";
var DateTimePicker = /** @class */ (function (_super) {
    tslib_1.__extends(DateTimePicker, _super);
    function DateTimePicker(props) {
        var _this = _super.call(this, props) || this;
        _this._value = new Date();
        _this._getErrorMessage = function (value) {
            var _a = _this.props.parseTimeFromString, parseTimeFromString = _a === void 0 ? _this._defaultParseTimeFromString : _a;
            return !!parseTimeFromString(value) ? '' : Resources.DateTimePicker_CannotParseTime;
        };
        if (props) {
            if ('value' in props) {
                warn("'value' will be ignored. Use 'defaultValue'.");
            }
            if ('onSelectDate' in props) {
                warn("'onSelectDate' will be ignored.");
            }
            _this._value = props.defaultValue;
        }
        return _this;
    }
    DateTimePicker.prototype.render = function () {
        var _this = this;
        var _a = this.props, _b = _a.formatTime, formatTime = _b === void 0 ? this._defaultformatTime : _b, _c = _a.parseTimeFromString, parseTimeFromString = _c === void 0 ? this._defaultParseTimeFromString : _c;
        return React.createElement("div", { className: "vss-DateTimePicker" },
            React.createElement("div", { className: "vss-DateTimePicker--dateField" },
                React.createElement(DatePicker, tslib_1.__assign({ isMonthPickerVisible: false }, this.props, { value: this._value, ariaLabel: this.props.dateAriaLabel || Resources.DateTimePicker_DateFieldAriaLabel, onSelectDate: function (date) {
                        if (_this._value) {
                            _this._value.setFullYear(date.getFullYear(), date.getMonth(), date.getDate());
                        }
                        if (_this.props.onValueChanged) {
                            _this.props.onValueChanged(_this._value);
                        }
                    } }))),
            React.createElement("div", { className: "vss-DateTimePicker--timeField" },
                React.createElement(TextField, { defaultValue: formatTime(this._value), onGetErrorMessage: this._getErrorMessage, validateOnFocusOut: true, ariaLabel: this.props.timeAriaLabel || Resources.DateTimePicker_TimeFieldAriaLabel, onChanged: function (newValue) {
                        var parsedTime = parseTimeFromString(newValue);
                        if (!!parsedTime) {
                            _this._value.setHours(parsedTime.getHours(), parsedTime.getMinutes(), parsedTime.getSeconds());
                            if (_this.props.onValueChanged) {
                                _this.props.onValueChanged(_this._value);
                            }
                        }
                    } })));
    };
    DateTimePicker.prototype._defaultParseTimeFromString = function (timeStr) {
        var date = Date.parse(timeStr);
        if (date) {
            return new Date(date);
        }
        return null;
    };
    DateTimePicker.prototype._defaultformatTime = function (date) {
        if (date) {
            return date.toLocaleTimeString();
        }
        return '';
    };
    return DateTimePicker;
}(BaseComponent));
export { DateTimePicker };
