import * as tslib_1 from "tslib";
import * as React from 'react';
import { DateTimePicker } from '../../Components/DateTimePicker/DateTimePicker';
import { FilterBarItem } from '../../FilterBar';
var DateTimePickerFilterBarItem = /** @class */ (function (_super) {
    tslib_1.__extends(DateTimePickerFilterBarItem, _super);
    function DateTimePickerFilterBarItem() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._onSelectionChanged = function (newDate) {
            _this.setFilterValue({ value: newDate });
        };
        return _this;
    }
    DateTimePickerFilterBarItem.prototype.focus = function () {
        //DateTimePicker needs a focus() method for this to work, but Office Fabric DatePicker does not have a focus9) method yet.
        return false;
    };
    DateTimePickerFilterBarItem.prototype.componentWillMount = function () {
        this.props.filter.setFilterItemState(this.props.filterItemKey, { value: this.props.defaultValue });
    };
    DateTimePickerFilterBarItem.prototype.render = function () {
        return React.createElement(DateTimePicker, { defaultValue: this.props.defaultValue, formatDate: this.props.formatDate, formatTime: this.props.formatTime, parseTimeFromString: this.props.parseTimeFromString, onValueChanged: this._onSelectionChanged });
    };
    DateTimePickerFilterBarItem.prototype.onFilterChanged = function (filterState) {
    };
    return DateTimePickerFilterBarItem;
}(FilterBarItem));
export { DateTimePickerFilterBarItem };
