import * as tslib_1 from "tslib";
import "../../FabricInit";
import * as React from "react";
import { BaseComponent } from "office-ui-fabric-react/lib/Utilities";
import * as Resources from '../../VSS.Resources.VSSUI';
import { DateTimePicker } from "../../DateTimePicker";
import "./DateTimeRangePicker.css";
var DateTimeRangePicker = /** @class */ (function (_super) {
    tslib_1.__extends(DateTimeRangePicker, _super);
    function DateTimeRangePicker(props) {
        var _this = _super.call(this, props) || this;
        if (props) {
            _this._startTime = props.defaultStartTime;
            _this._endTime = props.defaultEndTime;
        }
        return _this;
    }
    DateTimeRangePicker.prototype.render = function () {
        var _this = this;
        return React.createElement("div", { className: "vss-DateTimeRangePicker" },
            React.createElement("div", null,
                React.createElement("span", { className: "vss-DateTimeRangePicker--label" }, Resources.DateTimeRangePicker_Start),
                React.createElement(DateTimePicker, { defaultValue: this._startTime, formatDate: this.props.formatDate, formatTime: this.props.formatTime, parseTimeFromString: this.props.parseTimeFromString, onValueChanged: function (date) {
                        _this._startTime = date;
                        if (_this.props.onValueChanged) {
                            _this.props.onValueChanged(_this._startTime, _this._endTime);
                        }
                    }, dateAriaLabel: Resources.DateTimeRangePicker_StartDate, timeAriaLabel: Resources.DateTimeRangePicker_StartTime })),
            React.createElement("div", null,
                React.createElement("span", { className: "vss-DateTimeRangePicker--label" }, Resources.DateTimeRangePicker_End),
                React.createElement(DateTimePicker, { defaultValue: this._endTime, formatDate: this.props.formatDate, formatTime: this.props.formatTime, parseTimeFromString: this.props.parseTimeFromString, onValueChanged: function (date) {
                        _this._endTime = date;
                        if (_this.props.onValueChanged) {
                            _this.props.onValueChanged(_this._startTime, _this._endTime);
                        }
                    }, dateAriaLabel: Resources.DateTimeRangePicker_EndDate, timeAriaLabel: Resources.DateTimeRangePicker_EndTime })));
    };
    return DateTimeRangePicker;
}(BaseComponent));
export { DateTimeRangePicker };
