//dependencies=
// Copyright (C) Microsoft Corporation. All rights reserved.
define("VSSUI/Components/FileInput/FileInput.Props", ["require", "exports"], function (require, exports) {
    Object.defineProperty(exports, "__esModule", { value: true });
    /**
     * File encoding values.
     */
    var FileEncoding;
    (function (FileEncoding) {
        FileEncoding[FileEncoding["Unknown"] = 0] = "Unknown";
        FileEncoding[FileEncoding["Binary"] = 1] = "Binary";
        FileEncoding[FileEncoding["ASCII"] = 2] = "ASCII";
        FileEncoding[FileEncoding["UTF8"] = 3] = "UTF8";
        FileEncoding[FileEncoding["UTF32_BE"] = 4] = "UTF32_BE";
        FileEncoding[FileEncoding["UTF32_LE"] = 5] = "UTF32_LE";
        FileEncoding[FileEncoding["UTF16_BE"] = 6] = "UTF16_BE";
        FileEncoding[FileEncoding["UTF16_LE"] = 7] = "UTF16_LE";
    })(FileEncoding = exports.FileEncoding || (exports.FileEncoding = {}));
    /**
     * Specifies how a file is uploaded to the server.
     */
    var FileInputContentType;
    (function (FileInputContentType) {
        /**
         * The file is base64-encoded.
         */
        FileInputContentType[FileInputContentType["Base64EncodedText"] = 0] = "Base64EncodedText";
        /**
         * The file is uploaded as a string.
         */
        FileInputContentType[FileInputContentType["RawText"] = 1] = "RawText";
        /**
         * The file is uploaded directly.
         */
        FileInputContentType[FileInputContentType["RawFile"] = 2] = "RawFile";
    })(FileInputContentType = exports.FileInputContentType || (exports.FileInputContentType = {}));
});
//# sourceMappingURL=FileInput.Props.js.map
//direct-dependencies=