/// <reference types="react" />
import "../../FabricInit";
import { BaseComponent } from 'office-ui-fabric-react/lib/Utilities';
import { IFilterBar, IFilterBarProps } from '../../Components/FilterBar/FilterBar.Props';
import "./FilterBar.css";
export interface IFilterBarState {
    hasChangesToApply?: boolean;
    hasChangesToReset?: boolean;
    filtersToShowStartIndex: number;
    filtersToShowStopIndex: number;
    shouldHidePlaceholderLabels: boolean;
    shouldHaveMaxItemWidth: boolean;
}
export declare class FilterBar extends BaseComponent<IFilterBarProps, IFilterBarState> implements IFilterBar {
    private _filterItemRefs;
    private _childrenContainerElements;
    private _rightElement;
    private _filterBarElement;
    private _resizeTimeout;
    private _startingFilterIndices;
    private _hasMadeVisibleFilterAnnouncement;
    private _isMounted;
    private _prevButtonElem;
    private _nextButtonElem;
    private _hasPagedRight;
    private _hasPagedLeft;
    private static RENDER_EVERYTHING;
    private _firstChildIsKeywordItem;
    private _prevContainerWidth;
    constructor(props: IFilterBarProps);
    focus(): void;
    forceUpdate(): void;
    componentDidMount(): void;
    private getChildKeysAsString;
    componentWillReceiveProps(nextProps: IFilterBarProps): void;
    componentWillUnmount(): void;
    componentDidUpdate(): void;
    render(): JSX.Element;
    private _onResize;
    private _onPageLeft;
    private _onPageRight;
    private _calculateFiltersToShowStopIndex;
    private _getAppliedFilterCount;
    private _onFilterChanged;
    private _onFilterApplied;
    private _onClearAndDismiss;
    private _onApplyChanges;
}
