import * as tslib_1 from "tslib";
import "../../FabricInit";
import * as React from 'react';
import { Icon } from 'office-ui-fabric-react/lib/Icon';
import { TextFilterBarItem } from '../../Components/FilterBar/TextFilterBarItem';
import * as VSSUIResources from '../../VSS.Resources.VSSUI';
var KeywordFilterBarItem = /** @class */ (function (_super) {
    tslib_1.__extends(KeywordFilterBarItem, _super);
    function KeywordFilterBarItem() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._onRenderPrefix = function () {
            return React.createElement(Icon, { iconName: "Filter", className: "keyword-filter-icon", onClick: _this._onIconClick });
        };
        _this._onIconClick = function () {
            _this.focus();
        };
        return _this;
    }
    KeywordFilterBarItem.prototype.getExtraTextFieldProps = function () {
        var placeholder = this.props.placeholder || VSSUIResources.KeywordFilterBarItemPlaceholderText;
        return {
            className: "vss-FilterBar--item-keyword",
            onRenderPrefix: this._onRenderPrefix,
            placeholder: placeholder,
            ariaLabel: placeholder,
            role: "search"
        };
    };
    return KeywordFilterBarItem;
}(TextFilterBarItem));
export { KeywordFilterBarItem };
