/**
 * Which direction focus moves within a FocusZone
 */
export const enum FocusZoneDirection {
    Horizontal = 1,
    Vertical = 2
}

export interface IFocusZoneProps {
    /**
     * A selector for the element to receive focus when the FocusZone mounts.
     */
    defaultActiveElement?: string;

    /**
     * The direction that focus moves within the FocusZone.
     */
    direction: FocusZoneDirection;

    /**
     * When set to true, the FocusZone will stop managing focus.
     */
    disabled?: boolean;

    /**
     * If set to true, focus will be able to move from the last element to the first or vice versa.
     */
    isCircularNavigation?: boolean;

    /**
     * Whether the FocusZone should focus a default element when it mounts or not.
     */
    shouldFocusOnMount?: boolean;
}