import "../../FabricInit";
import { IBaseProps } from "office-ui-fabric-react/lib/Utilities";
import { IContextualMenuItem } from "office-ui-fabric-react/lib/ContextualMenu";
import { ITooltipHostProps } from '../../Tooltip';
import { IFilter, FILTER_CHANGE_EVENT } from '../../Utilities/Filter';
import { IObservableValue } from '../../Core/Observable';
export interface IHeaderCommandBar {

}

export interface IHeaderCommandBarItem extends IContextualMenuItem {
    /**
     * Determines if we render as a primary button or not
     */
    isPrimary?: boolean;

    /**
     * Optional tooltip props to display
     */
    tooltipProps?: ITooltipHostProps;
}

export interface IHeaderCommandBarProps extends IBaseProps<IHeaderCommandBar> {
    /**
     * Items to display in the far-right Command Bar
     * Should influence page-wide state
     */
    contextualMenuItems: IHeaderCommandBarItem[];

    /**
     * Items to display in the View Actions Bar, to the left othe Command Bar (if it exists)
     * Do not use if your page content includes a PivotBar; include your View Actions on the PivotBar
     */
    viewMenuItems?: IHeaderCommandBarItem[];

    /**
     * Additional classes to be applied to component
     */
    className?: string;
}

export interface IHeaderCommandBarWithFilterProps extends IHeaderCommandBarProps {
    /**
     * A filter object to listen to changes on. When there are changes, the filter icon
     * will be displayed as filled.
     */
    filter: IFilter;

    /**
     * The current state of whether the filter is visible or hidden. The value is toggled
     * by the onClick on the item.
     */
    filterToggled: IObservableValue<boolean | undefined>
}