/// <reference types="react" />
import "../../FabricInit";
import { BaseComponent } from "office-ui-fabric-react/lib/Utilities";
import { IHubHeaderProps } from "../../Components/HubHeader/HubHeader.Props";
import { IItemPickerProvider } from '../../PickList';
import "./HubHeader.css";
export interface IHubHeaderState {
    headerItemPicker?: IItemPickerProvider;
    canBreadcrumbShrink: boolean;
}
/**
 * Component that generates a standard VSTS page header.
 */
export declare class HubHeader extends BaseComponent<IHubHeaderProps, IHubHeaderState> {
    private _hubBreadcrumb;
    constructor(props: IHubHeaderProps);
    componentWillMount(): void;
    componentWillUnmount(): void;
    componentWillReceiveProps(nextProps: IHubHeaderProps): void;
    /**
     * Gets the title (Breadcrumb control or HubTitle control, depending on whether or not breadcrumbitems were passed).
     */
    private getTitle;
    private getBreadcrumb;
    private dataDidRender;
    private onSelectionChanged;
    private onHeaderPickerChanged;
    render(): JSX.Element;
}
