import * as tslib_1 from "tslib";
import "../../FabricInit";
import * as React from "react";
import { BaseComponent, css } from "office-ui-fabric-react/lib/Utilities";
import "./HubTileRegion.css";
/**
 * Component that contains hub tiles to be displayed in the PivotBar.
 */
var HubTileRegion = /** @class */ (function (_super) {
    tslib_1.__extends(HubTileRegion, _super);
    function HubTileRegion() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HubTileRegion.prototype.render = function () {
        var className = css('vss-HubTileRegion');
        var propsChildren = React.Children.toArray(this.props.children);
        var children = React.Children.map(propsChildren || [], function (item, index) {
            var originalChild = item;
            var originalProps = originalChild.props;
            var originalClassName = originalProps && originalProps.className;
            var clonedElementProps = tslib_1.__assign({}, originalProps, { className: originalClassName
                    ? originalClassName + ' vss-HubTile'
                    : 'vss-HubTile' });
            return React.cloneElement(item, clonedElementProps);
        });
        return (React.createElement("div", { className: className }, children));
    };
    return HubTileRegion;
}(BaseComponent));
export { HubTileRegion };
