import * as tslib_1 from "tslib";
import "../../FabricInit";
import * as React from "react";
import { BaseComponent, css } from "office-ui-fabric-react/lib/Utilities";
import { VssIcon } from '../../VssIcon';
import "./HubTitle.css";
/**
 * Component that generates a standard VSTS page header.
 */
var HubTitle = /** @class */ (function (_super) {
    tslib_1.__extends(HubTitle, _super);
    function HubTitle(props) {
        return _super.call(this, props) || this;
    }
    HubTitle.prototype.getIcon = function () {
        if (this.props.iconProps) {
            var iconProps = tslib_1.__assign({}, this.props.iconProps, { className: css(this.props.iconProps.className, "vss-HubTitle-titleIcon") });
            return React.createElement(VssIcon, tslib_1.__assign({}, iconProps));
        }
        return null;
    };
    HubTitle.prototype.getTitleText = function () {
        return (React.createElement("div", { className: "vss-HubTitle--titleText" }, this.props.titleText));
    };
    HubTitle.prototype.render = function () {
        var className = css("vss-HubTitle");
        return (React.createElement("h1", { className: className, onClick: this.props.onClick },
            this.getIcon(),
            this.getTitleText()));
    };
    return HubTitle;
}(BaseComponent));
export { HubTitle };
