import * as tslib_1 from "tslib";
import { Observable } from '../../Core/Observable';
export var ITEM_CHANGE_EVENT = 'item-changed';
var Item = /** @class */ (function (_super) {
    tslib_1.__extends(Item, _super);
    function Item(props) {
        var _this = _super.call(this) || this;
        _this._currentState = tslib_1.__assign({}, props.initialState);
        return _this;
    }
    /**
     * Gets the current state of the item.
     */
    Item.prototype.getState = function () {
        return this._currentState;
    };
    /**
     * Sets a new state for the item.
     * @param state New item state.
     * @param supressChangeEvent If true, don't invoke changed callback at this time.
     */
    Item.prototype.setState = function (state, supressChangeEvent) {
        if (supressChangeEvent === void 0) { supressChangeEvent = false; }
        this._currentState = state;
        if (!supressChangeEvent) {
            this.notify(state, ITEM_CHANGE_EVENT);
        }
    };
    return Item;
}(Observable));
export { Item };
