import * as tslib_1 from "tslib";
import "../../FabricInit";
import "../../Core/core.scss";
import "../../Common.scss";
import "./layer.scss";
import * as React from 'react';
import { css, BaseComponent } from 'office-ui-fabric-react/lib/Utilities';
var Layer = /** @class */ (function (_super) {
    tslib_1.__extends(Layer, _super);
    function Layer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Layer.prototype.render = function () {
        var _this = this;
        var _a = this.props, contentJustification = _a.contentJustification, contentLocation = _a.contentLocation, contentOrientation = _a.contentOrientation, contentSize = _a.contentSize, isLightDismiss = _a.isLightDismiss, isModal = _a.isModal;
        return (React.createElement("div", { "aria-label": this.props.ariaLabel, className: css(this.props.className, "layer absolute-fill", contentJustification === 0 /* Start */ && "justify-start", contentJustification === 1 /* Center */ && "justify-center", contentJustification === 2 /* End */ && "justify-end", contentLocation === 0 /* Start */ && "flex-start", contentLocation === 1 /* Center */ && "flex-center", contentLocation === 2 /* End */ && "flex-end", contentOrientation === 0 /* Vertical */ && "flex-column", contentOrientation === 1 /* Horizontal */ && "flex-row", isModal && "modal", isLightDismiss && "light-dismiss"), id: this.props.id, ref: function (element) { _this.element = element; }, onKeyDown: function (event) {
                // If we press escape from within the layer and this layer dismiss it.
                if (_this.props.isEscDismiss && event.which === 27 && !event.defaultPrevented) {
                    _this.props.onDismiss && _this.props.onDismiss();
                    event.preventDefault();
                }
            }, onMouseDown: function (event) {
                // If we click on the layer and not inside the content, with light dismiss, we will dismiss ourselves.
                if (_this.props.isLightDismiss && _this.element === event.target) {
                    _this.props.onDismiss && _this.props.onDismiss();
                    event.preventDefault();
                }
            } },
            React.createElement("div", { className: css(this.props.contentClassName, "layer-content", contentJustification === 3 /* Stretch */ && "flex-grow", contentOrientation === 0 /* Vertical */ && "flex-column", contentOrientation === 1 /* Horizontal */ && "flex-row", this.props.contentShadow && "shadow", contentSize === 0 /* Small */ && "small", contentSize === 1 /* Medium */ && "medium", contentSize === 2 /* Large */ && "large"), role: "dialog" }, this.props.children)));
    };
    return Layer;
}(BaseComponent));
export { Layer };
