export interface IPortal {

}

/**
 * IPortalProperties are used to initialize an Portal component. They allow you to control
 * where the portal is hosted.
 */
export interface IPortalProps {
    /**
     * Optional callback to access the IPortal interface. Use this instead of ref for accessing
     * the public methods and properties of the component.
     */
    componentRef?: (component: IPortal | null) => void;


    /**
     * Optional selector for the parentElement that will contain the portal tree.
     */
    portalSelector?: string;

    /**
     * Optional parentElement that will contain the portal tree.
     */
    portalElement?: HTMLElement;
}