import * as tslib_1 from "tslib";
import "../../FabricInit";
import * as ReactDOM from 'react-dom';
import { BaseComponent } from 'office-ui-fabric-react/lib/Utilities';
/**
 * The Portal component is used to create a React Portal through a well known component.
 * This component allows the platform to control where portals are rooted in the document
 * and ensure these are managed properly.
 */
var Portal = /** @class */ (function (_super) {
    tslib_1.__extends(Portal, _super);
    function Portal(props) {
        var _this = _super.call(this, props) || this;
        // Determine the element that will host the portal.
        _this.parentElement = _this.props.portalElement || (_this.props.portalSelector && document.querySelector(_this.props.portalSelector)) || document.body;
        // Create the hosting element for the portal.
        _this.hostElement = document.createElement("div");
        return _this;
    }
    Portal.prototype.render = function () {
        return ReactDOM.createPortal(this.props.children, this.hostElement);
    };
    Portal.prototype.componentDidMount = function () {
        this.parentElement.appendChild(this.hostElement);
    };
    Portal.prototype.componentWillUnmount = function () {
        this.parentElement.removeChild(this.hostElement);
    };
    return Portal;
}(BaseComponent));
export { Portal };
