import "../../FabricInit";
import * as React from "react";
import { IBaseProps } from "office-ui-fabric-react/lib/Utilities";
import { IVssContributedTabProvider, ITabGroupProvider } from "../../Components/Tabs/Tabs.Props";

export const enum Orientation {
    Vertical,
    Horizontal
}

/**
 * Properties for the Page component.
 */
export interface IPageProps {
    /**
     * Optional root classname for the page element.
     */
    className?: string;

    /**
     * Tracks the selected tab id within the page.
     */
    selectedTabId?: IReadonlyObservableValue<string>;

    /**
     * A list of providers contributing tabs to the page.
     */
    tabProviders?: IVssContributedTabProvider[];

    /**
     * A list of providers contributing tab groups to the page.
     */
    tabGroupProviders?: ITabGroupProvider[];

    /**
     * Describes if the page should render elements in a flex-row
     * or flex-column
     */
    orientation?: Orientation;
}