import * as tslib_1 from "tslib";
import "../../FabricInit";
import * as React from "react";
import { css } from "office-ui-fabric-react/lib/Utilities";
import { TabProvider, TabGroupProvider } from "../../Tabs";
/**
 * Component for stitching together the various components that make a up a page.
 * Renders all children in a column-based flexbox.
 * If passed an observable selected tab id and contributed tab providers, will
 * wrap with a TabProvider component to provide context to consuming children.
 */
var Page = /** @class */ (function (_super) {
    tslib_1.__extends(Page, _super);
    function Page() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Page.prototype.render = function () {
        var _a = this.props, tabProviders = _a.tabProviders, selectedTabId = _a.selectedTabId, tabGroupProviders = _a.tabGroupProviders, _b = _a.orientation, orientation = _b === void 0 ? 0 /* Vertical */ : _b;
        var orientationClass = orientation === 0 /* Vertical */ ? "flex-column" : "flex-row";
        var page = (React.createElement("div", { className: css("vss-Page v-scroll-auto", orientationClass, this.props.className) }, this.props.children));
        if (this.props.selectedTabId) {
            page = (React.createElement(TabProvider, { providers: tabProviders || [], selectedTabId: selectedTabId }, page));
        }
        if (this.props.tabGroupProviders) {
            page = (React.createElement(TabGroupProvider, { providers: tabGroupProviders }, page));
        }
        return page;
    };
    return Page;
}(React.Component));
export { Page };
