import * as tslib_1 from "tslib";
import "../../FabricInit";
import * as React from "react";
import * as Resources from '../../VSS.Resources.VSSUI';
import { NormalPeoplePicker } from "office-ui-fabric-react/lib/Pickers";
import { createRef, BaseComponent, format } from "office-ui-fabric-react/lib/Utilities";
import { convertIdentityListToPersonaList } from "./PeoplePickerUtils";
var PeoplePicker = /** @class */ (function (_super) {
    tslib_1.__extends(PeoplePicker, _super);
    function PeoplePicker() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._peoplePicker = createRef();
        _this._getfilteredPersonas = function (filter) {
            return convertIdentityListToPersonaList(_this.props.pickerProvider.onFilterIdentities(filter));
        };
        _this._resultsFooter = function () {
            return _this._peoplePicker.current && _this._peoplePicker.current.items.length > 0 ? (React.createElement("div", { className: "vss-NoIdentitiesFound" }, format(Resources.PeoplePickerResultsFoundText, _this._peoplePicker.current.items))) : null;
        };
        _this._onRenderNoIdentitiesFound = function () {
            return React.createElement("div", { className: "vss-NoIdentitiesFound" }, Resources.PeoplePickerNoResultsText);
        };
        return _this;
    }
    PeoplePicker.prototype.render = function () {
        var suggestionsProps = {
            onRenderNoResultFound: this._onRenderNoIdentitiesFound,
            resultsFooter: this._resultsFooter
        };
        var inputProps = {
            placeholder: Resources.PeoplePickerPlaceholderText
        };
        return (React.createElement(NormalPeoplePicker, { componentRef: this._peoplePicker, className: "vss-PeoplePicker", pickerSuggestionsProps: suggestionsProps, inputProps: inputProps, resolveDelay: 200, searchingText: Resources.PeoplePickerLoadingText, onResolveSuggestions: this._getfilteredPersonas }));
    };
    return PeoplePicker;
}(BaseComponent));
export { PeoplePicker };
