import "../../FabricInit";
import { PersonaSize } from "office-ui-fabric-react/lib/Persona";
export function convertIdentityToPersona(identity) {
    return {
        imageUrl: identity.image,
        text: identity.displayName,
        showSecondaryText: !!identity.displayName && identity.displayName !== "",
        secondaryText: getSignInAddress(identity),
        size: PersonaSize.extraExtraSmall
    };
}
export function convertIdentityListToPersonaList(entities) {
    var suggestionsArray = entities;
    var suggestionsPromiseLike = entities;
    if (Array.isArray(suggestionsArray)) {
        return suggestionsArray.map(function (x) { return convertIdentityToPersona(x); });
    }
    else if (suggestionsPromiseLike && suggestionsPromiseLike.then) {
        return suggestionsPromiseLike.then(function (results) { return results.map(function (x) { return convertIdentityToPersona(x); }); });
    }
    else {
        return null;
    }
}
function getSignInAddress(identity) {
    if (!identity.isHosted && identity.samAccountName && identity.samAccountName.trim()) {
        return (identity.scopeName && identity.scopeName.trim() ? identity.scopeName + "\\" : "") + identity.samAccountName;
    }
    return identity.signInAddress && identity.signInAddress.trim()
        ? identity.signInAddress
        : identity.mail && identity.mail.trim()
            ? identity.mail
            : identity.mailNickname && identity.mailNickname.trim()
                ? identity.mailNickname
                : "";
}
