/// <reference types="react" />
import "../../FabricInit";
import { BaseComponent } from "office-ui-fabric-react/lib/Utilities";
import { IButton } from "office-ui-fabric-react/lib/Button";
import { ISuggestionsProps } from "office-ui-fabric-react/lib/Pickers";
import { ISuggestionItemProps } from "./Suggestions.Props";
export declare enum SuggestionActionType {
    none = 0,
    forceResolve = 1,
    searchMore = 2
}
export interface ISuggestionsState {
    selectedActionType: SuggestionActionType;
}
export declare class SuggestionsItem<T> extends BaseComponent<ISuggestionItemProps<T>, {}> {
    render(): JSX.Element;
}
export declare class Suggestions<T> extends BaseComponent<ISuggestionsProps<T>, ISuggestionsState> {
    protected _forceResolveButton: import("../../../node_modules/@uifabric/utilities/lib/createRef").RefObject<IButton>;
    protected _searchForMoreButton: import("../../../node_modules/@uifabric/utilities/lib/createRef").RefObject<IButton>;
    protected _selectedElement: import("../../../node_modules/@uifabric/utilities/lib/createRef").RefObject<HTMLDivElement>;
    private SuggestionsItemOfProperType;
    private activeSelectedElement;
    constructor(suggestionsProps: ISuggestionsProps<T>);
    componentDidMount(): void;
    componentDidUpdate(): void;
    render(): JSX.Element;
    /**
     * Returns true if the event was handled, false otherwise
     */
    tryHandleKeyDown: (keyCode: number, currentSuggestionIndex: number) => boolean;
    hasSuggestedAction(): boolean;
    hasSuggestedActionSelected(): boolean;
    executeSelectedAction(): void;
    focusAboveSuggestions(): void;
    focusBelowSuggestions(): void;
    focusSearchForMoreButton(): void;
    scrollSelected(): void;
    private _renderSuggestions;
    private _getMoreResults;
    private _forceResolve;
    private _shouldShowForceResolve;
    private _onClickTypedSuggestionsItem;
    private _refocusOnSuggestions;
    private _onRemoveTypedSuggestionsItem;
}
