/// <reference types="react" />
import "../../FabricInit";
import { IPeoplePickerDropdownProps, IPeoplePickerDropdown } from "./PeoplePickerDropdown.Props";
import { IIdentity } from "../PeoplePicker/SharedPeoplePicker.Props";
import { BaseComponent } from "office-ui-fabric-react/lib/Utilities";
export interface IPeoplePickerDropdownState {
    isMostRecentlyUsedVisible: boolean;
    searchValue: string;
    hasFocus: boolean;
    suggestionsVisible: boolean;
    suggestionsLoading?: boolean;
    openedIdentityCard?: IIdentity;
}
export declare class PeoplePickerDropdown extends BaseComponent<IPeoplePickerDropdownProps, IPeoplePickerDropdownState> implements IPeoplePickerDropdown {
    private _suggestionsControl;
    private _suggestionStore;
    private _outerElement;
    private _inputElement;
    private _loadingTimer;
    private _currentPromise;
    private _cachedResults;
    constructor(props: IPeoplePickerDropdownProps);
    render(): JSX.Element;
    componentDidMount(): void;
    hidePicker: () => void;
    showPicker: () => void;
    updateSuggestionsList(suggestions: IIdentity[] | PromiseLike<IIdentity[]>, initialSearchValue?: string): void;
    private _updateSuggestions;
    private _onFocus;
    private _onClick;
    private _onBlur;
    private _onSearchChange;
    private _onKeyDown;
    private _setInputToSelectedPerson;
    private _onResolveSuggestions;
    private _updateValue;
    private _onSuggestionClick;
    private _completeSuggestion;
    private _onRenderSuggestions;
    private _onRenderNoIdentitiesFound;
    private _resultsFooter;
    private _renderSuggestions;
}
