import * as tslib_1 from "tslib";
import "../../FabricInit";
import * as React from "react";
import { Suggestions } from "../PeoplePicker/Suggestions";
import { PersonaSize, PersonaCoin, Persona } from "office-ui-fabric-react/lib/Persona";
import { Callout } from "office-ui-fabric-react/lib/Callout";
import { SuggestionsController } from "office-ui-fabric-react/lib/Pickers";
import { BaseComponent, createRef, css, format } from "office-ui-fabric-react/lib/Utilities";
import { VssIcon } from '../../VssIcon';
import { convertIdentityToPersona } from "../PeoplePicker/PeoplePickerUtils";
import { PersonaCard } from "../PersonaCard";
import * as Resources from '../../VSS.Resources.VSSUI';
var PeoplePickerDropdown = /** @class */ (function (_super) {
    tslib_1.__extends(PeoplePickerDropdown, _super);
    function PeoplePickerDropdown(props) {
        var _this = _super.call(this, props) || this;
        _this._suggestionsControl = createRef();
        _this._outerElement = createRef();
        _this._inputElement = createRef();
        _this.hidePicker = function () {
            _this.setState({
                suggestionsVisible: false
            });
        };
        _this.showPicker = function () {
            _this.setState({
                suggestionsVisible: true
            });
        };
        _this._onFocus = function (e) {
            var onFocus = _this.props.onFocus;
            if (_this._inputElement.current && _this._inputElement.current.value === "" && _this.props.pickerProvider.onEmptyInputFocus) {
                _this.updateSuggestionsList(_this.props.pickerProvider.onEmptyInputFocus());
                _this.setState({ isMostRecentlyUsedVisible: true });
            }
            _this.setState({ hasFocus: true });
            if (onFocus) {
                onFocus(e);
            }
        };
        _this._onClick = function () {
            if (_this.state.openedIdentityCard) {
                _this.setState({ openedIdentityCard: undefined });
            }
            else if (_this._inputElement.current && _this._inputElement.current.value === "" && _this.props.pickerProvider.onEmptyInputFocus) {
                _this.updateSuggestionsList(_this.props.pickerProvider.onEmptyInputFocus());
                _this.setState({ isMostRecentlyUsedVisible: true, suggestionsVisible: !_this.state.suggestionsVisible });
            }
            else {
                _this.setState({
                    suggestionsVisible: !_this.state.suggestionsVisible,
                    isMostRecentlyUsedVisible: _this._inputElement.current.value === ""
                });
            }
            _this._inputElement.current.select();
        };
        _this._onBlur = function (e) {
            var onBlur = _this.props.onBlur;
            _this._setInputToSelectedPerson();
            _this.setState({ hasFocus: false });
            if (onBlur) {
                onBlur(e);
            }
        };
        _this._onSearchChange = function () {
            var newValue = _this._inputElement.current.value;
            if (newValue !== _this.state.searchValue) {
                _this._updateValue(newValue);
                _this._suggestionStore.deselectAllSuggestions();
                _this._suggestionStore.currentSuggestion = undefined;
                _this.setState({
                    searchValue: newValue,
                    suggestionsVisible: true,
                    isMostRecentlyUsedVisible: false
                });
            }
        };
        _this._onKeyDown = function (ev) {
            var keyCode = ev.which;
            switch (keyCode) {
                case 27 /* escape */:
                    if (_this.state.suggestionsVisible) {
                        _this.setState({ suggestionsVisible: false, openedIdentityCard: undefined });
                    }
                    break;
                case 9 /* tab */:
                case 13 /* enter */:
                    if (_this._suggestionsControl.current && _this._suggestionsControl.current.hasSuggestedActionSelected()) {
                        _this._suggestionsControl.current.executeSelectedAction();
                        _this._completeSuggestion();
                    }
                    else if (!ev.shiftKey && _this._suggestionStore.hasSelectedSuggestion() && _this.state.suggestionsVisible) {
                        _this._completeSuggestion();
                        ev.preventDefault();
                        ev.stopPropagation();
                    }
                    else {
                        _this._completeSuggestion();
                    }
                    break;
                case 39 /* right */:
                    if (_this._suggestionStore.currentSuggestion) {
                        _this.setState({ openedIdentityCard: _this._suggestionStore.currentSuggestion.item });
                    }
                    break;
                case 38 /* up */:
                    if (_this._suggestionsControl.current &&
                        _this._suggestionsControl.current.tryHandleKeyDown(keyCode, _this._suggestionStore.currentIndex)) {
                        ev.preventDefault();
                        ev.stopPropagation();
                    }
                    else {
                        if (_this._suggestionsControl.current && _this.state.suggestionsVisible) {
                            _this._suggestionStore.previousSuggestion();
                            _this._setInputToSelectedPerson();
                        }
                    }
                    break;
                case 40 /* down */:
                    if (_this._suggestionsControl.current &&
                        _this._suggestionsControl.current.tryHandleKeyDown(keyCode, _this._suggestionStore.currentIndex)) {
                        ev.preventDefault();
                        ev.stopPropagation();
                    }
                    else {
                        if (_this._suggestionsControl.current && _this.state.suggestionsVisible) {
                            _this._suggestionStore.nextSuggestion();
                            _this._setInputToSelectedPerson();
                        }
                        else {
                            _this.setState({ suggestionsVisible: true });
                        }
                    }
                    break;
            }
        };
        _this._setInputToSelectedPerson = function () {
            var currentValue = _this._inputElement.current ? _this._inputElement.current.value : "";
            var itemValue = _this._suggestionStore.currentSuggestion ? _this._suggestionStore.currentSuggestion.item.displayName : currentValue;
            _this.setState({ searchValue: itemValue });
        };
        _this._onSuggestionClick = function (ev, item, index) {
            _this._suggestionStore.setSelectedSuggestion(index);
            if (_this.props.onChange)
                _this.props.onChange(item);
            _this.setState({ searchValue: item.displayName, suggestionsVisible: false });
        };
        _this._completeSuggestion = function () {
            if (_this._suggestionStore.suggestions.length > 0 && _this._inputElement.value) {
                if (_this._suggestionStore.currentIndex < 0) {
                    _this._suggestionStore.nextSuggestion();
                }
                _this._setInputToSelectedPerson();
                _this.props.onChange && _this._suggestionStore.currentSuggestion && _this.props.onChange(_this._suggestionStore.currentSuggestion.item);
                _this.setState({
                    suggestionsVisible: false
                });
            }
        };
        _this._onRenderSuggestions = function (props, itemProps) {
            return (React.createElement("div", { className: "flex-row flex-grow vss-picker-suggesteditem" },
                React.createElement(Persona, tslib_1.__assign({ className: "flex-grow vss-picker-suggesteditem", size: PersonaSize.size28, imageShouldFadeIn: false, showSecondaryText: true }, convertIdentityToPersona(props))),
                React.createElement(VssIcon, { className: "flex-shrink vss-contact-card", iconType: 0 /* fabric */, iconName: "ContactCard", onClick: function (e) {
                        _this.setState({ openedIdentityCard: props });
                        e.stopPropagation();
                    } })));
        };
        _this._onRenderNoIdentitiesFound = function () {
            return React.createElement("div", { className: "vss-NoIdentitiesFound" }, Resources.PeoplePickerNoResultsText);
        };
        _this._resultsFooter = function (suggestedProps) {
            return suggestedProps.suggestions.length > 0 ? (React.createElement("div", null, format(Resources.PeoplePickerResultsFoundText, suggestedProps.suggestions.length))) : (undefined);
        };
        _this._suggestionStore = new SuggestionsController();
        _this._cachedResults = {};
        _this.state = {
            searchValue: "",
            hasFocus: props.autoFocus,
            suggestionsVisible: false,
            isMostRecentlyUsedVisible: false,
            openedIdentityCard: undefined
        };
        return _this;
    }
    PeoplePickerDropdown.prototype.render = function () {
        var _this = this;
        var _a = this.state, searchValue = _a.searchValue, hasFocus = _a.hasFocus, suggestionsVisible = _a.suggestionsVisible;
        var autoFocus = this.props.autoFocus;
        var currentPersona = this._suggestionStore.currentSuggestion && this._suggestionStore.currentSuggestion.item;
        var openClassName = {
            "vss-PeoplePickerDropdown-open": suggestionsVisible || hasFocus
        };
        return (React.createElement("div", null,
            React.createElement("div", { ref: this._outerElement, role: "comboBox", "aria-autocomplete": "list", "aria-label": Resources.PeoplePickerPlaceholderText, "aria-expanded": this.state.suggestionsVisible, className: css("vss-PeoplePickerDropdown flex-row flex-center", openClassName, this.props.className), onClick: this._onClick, onKeyDown: this._onKeyDown },
                currentPersona &&
                    !hasFocus &&
                    !suggestionsVisible && (React.createElement(PersonaCoin, tslib_1.__assign({}, convertIdentityToPersona(currentPersona), { size: PersonaSize.size16, className: "vss-PeoplePickerDropdown-icon" }))),
                React.createElement("input", { className: "vss-PeoplePickerDropdown-input flex-grow", onFocus: this._onFocus, ref: this._inputElement, placeholder: Resources.PeoplePickerPlaceholderText, onChange: this._onSearchChange, onBlur: this._onBlur, value: searchValue, autoFocus: autoFocus }),
                React.createElement(VssIcon, { className: css("vss-PeoplePickerDropdown-chevron", openClassName), iconType: 0 /* fabric */, iconName: "ChevronDown" }),
                this._renderSuggestions()),
            this.state.openedIdentityCard && (React.createElement(PersonaCard, { key: this.state.openedIdentityCard.entityId, identity: this.state.openedIdentityCard, target: this._outerElement.current, onDismissCallback: function () { return _this.setState({ openedIdentityCard: undefined }); }, onRequestConnectionInformation: this.props.pickerProvider.onRequestConnectionInformation, getEntityFromUniqueAttribute: this.props.pickerProvider.getEntityFromUniqueAttribute }))));
    };
    PeoplePickerDropdown.prototype.componentDidMount = function () {
        this._onResolveSuggestions = this._async.debounce(this._onResolveSuggestions, 250);
        if (this.props.defaultIdentity) {
            this._suggestionStore.currentSuggestion = { item: this.props.defaultIdentity, selected: true };
            this.setState({ searchValue: this.props.defaultIdentity.displayName });
        }
    };
    PeoplePickerDropdown.prototype.updateSuggestionsList = function (suggestions, initialSearchValue) {
        var _this = this;
        var suggestionsArray = suggestions;
        var suggestionsPromiseLike = suggestions;
        // Check to see if the returned value is an array, if it is then just pass it into the next function.
        // If the returned value is not an array then check to see if it's a promise or PromiseLike. If it is then resolve it asynchronously.
        if (Array.isArray(suggestionsArray)) {
            this._updateSuggestions(suggestionsArray);
        }
        else if (suggestionsPromiseLike && suggestionsPromiseLike.then) {
            if (!this._loadingTimer) {
                this._loadingTimer = this._async.setTimeout(function () {
                    _this.setState({
                        suggestionsLoading: true
                    });
                }, 500);
            }
            // Ensure that the promise will only use the callback if it was the most recent one.
            var promise_1 = (this._currentPromise = suggestionsPromiseLike);
            promise_1.then(function (newSuggestions) {
                if (promise_1 === _this._currentPromise) {
                    _this.setState({
                        suggestionsLoading: false
                    });
                    _this._updateSuggestions(newSuggestions, initialSearchValue);
                    if (_this.state.searchValue !== "" && _this._suggestionStore.suggestions && _this._suggestionStore.suggestions.length > 0) {
                        _this._cachedResults[_this.state.searchValue] = newSuggestions;
                    }
                    if (_this._loadingTimer) {
                        _this._async.clearTimeout(_this._loadingTimer);
                        _this._loadingTimer = undefined;
                    }
                }
            });
        }
    };
    PeoplePickerDropdown.prototype._updateSuggestions = function (suggestions, initialSearchValue) {
        // Only update the suggestions if the initial search value is the same as the current input
        if (!initialSearchValue || (this._inputElement.current && this._inputElement.current.value === initialSearchValue)) {
            this._suggestionStore.updateSuggestions(suggestions, 0);
            this.forceUpdate();
        }
    };
    PeoplePickerDropdown.prototype._onResolveSuggestions = function (updatedValue) {
        var suggestions = this.props.pickerProvider.onFilterIdentities(updatedValue, [
            this._suggestionStore.currentSuggestion && this._suggestionStore.currentSuggestion.item
        ]);
        if (suggestions !== null) {
            this.updateSuggestionsList(suggestions, updatedValue);
        }
    };
    PeoplePickerDropdown.prototype._updateValue = function (updatedValue) {
        if (this.props.pickerProvider.onEmptyInputFocus && !updatedValue) {
            this.updateSuggestionsList(this.props.pickerProvider.onEmptyInputFocus());
        }
        else if (this._cachedResults[updatedValue]) {
            this.updateSuggestionsList(this._cachedResults[updatedValue]);
        }
        else {
            this._onResolveSuggestions(updatedValue);
        }
    };
    PeoplePickerDropdown.prototype._renderSuggestions = function () {
        var _a = this.state, isMostRecentlyUsedVisible = _a.isMostRecentlyUsedVisible, suggestionsVisible = _a.suggestionsVisible, suggestionsLoading = _a.suggestionsLoading, openedIdentityCard = _a.openedIdentityCard;
        return suggestionsVisible || openedIdentityCard ? (React.createElement(Callout, { isBeakVisible: false, target: this._outerElement.current, onDismiss: this.hidePicker, calloutWidth: 300 },
            React.createElement(Suggestions, { isLoading: suggestionsLoading, loadingText: Resources.PeoplePickerLoadingText, className: "vss-PeoplePickerDropdown-list", suggestionsItemClassName: css("vss-PeoplePickerDropdown-item", this.props.suggestionsItemClassName), ref: this._suggestionsControl, resultsFooter: this._resultsFooter, isMostRecentlyUsedVisible: isMostRecentlyUsedVisible, onRenderNoResultFound: this._onRenderNoIdentitiesFound, onRenderSuggestion: this._onRenderSuggestions, onSuggestionClick: this._onSuggestionClick, suggestions: this._suggestionStore.getSuggestions(), isResultsFooterVisible: this.props.isResultsFooterVisible, resultsMaximumNumber: this.props.resultsMaximumNumber, suggestionsContainerAriaLabel: this.props.suggestionsContainerAriaLabel }))) : null;
    };
    return PeoplePickerDropdown;
}(BaseComponent));
export { PeoplePickerDropdown };
