import * as tslib_1 from "tslib";
import "../../FabricInit";
import * as React from "react";
import * as Resources from '../../VSS.Resources.VSSUI';
import { BaseComponent } from "office-ui-fabric-react/lib/Utilities";
import { Label } from "office-ui-fabric-react/lib/Label";
var ContactCardContactLine = /** @class */ (function (_super) {
    tslib_1.__extends(ContactCardContactLine, _super);
    function ContactCardContactLine() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    // Render
    ContactCardContactLine.prototype.render = function () {
        return (React.createElement("div", null,
            React.createElement("div", { className: this.props.padTop ? "contact-card-line-top" : "contact-card-line" },
                React.createElement("div", { className: "contact-card-span-label" }, this.props.label),
                React.createElement("div", { className: "contact-card-span-content" },
                    this.props.link &&
                        this.props.content && (React.createElement("a", { className: "profile-card-tab-element", href: this.props.link }, this.props.content)),
                    !this.props.link && this.props.content)),
            React.createElement("div", { style: { clear: "both" } })));
    };
    return ContactCardContactLine;
}(BaseComponent));
export { ContactCardContactLine };
var ContactCard = /** @class */ (function (_super) {
    tslib_1.__extends(ContactCard, _super);
    function ContactCard() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    // Render
    ContactCard.prototype.render = function () {
        var identity = this.props.identity;
        return (React.createElement("div", { className: "contact-or-organization-card-wrapper" },
            React.createElement("div", { className: "contact-card-header-wrapper" },
                React.createElement("div", { className: "body-m" },
                    React.createElement(Label, null, Resources.PeoplePickerContactInfo))),
            React.createElement("div", { className: "contact-card-info-wrapper" },
                React.createElement(ContactCardContactLine, { label: Resources.PeoplePickerEmail, content: identity.mail, link: "mailto:" + identity.mail }),
                React.createElement(ContactCardContactLine, { label: Resources.PeoplePickerPhoneNumber, content: identity.telephoneNumber, link: "mailto:" + identity.telephoneNumber }),
                React.createElement(ContactCardContactLine, { label: Resources.PeoplePickerLocation, content: identity.physicalDeliveryOfficeName }),
                React.createElement(ContactCardContactLine, { label: Resources.PeoplePickerTitle, content: identity.jobTitle, padTop: true }),
                React.createElement(ContactCardContactLine, { label: Resources.PeoplePickerDepartment, content: identity.department }),
                React.createElement(ContactCardContactLine, { label: Resources.PeoplePickerAlias, content: identity.mailNickname }))));
    };
    return ContactCard;
}(React.Component));
export { ContactCard };
