import * as tslib_1 from "tslib";
import "../../FabricInit";
import * as React from "react";
import * as Resources from '../../VSS.Resources.VSSUI';
import { Label } from "office-ui-fabric-react/lib/Label";
import { BaseComponent } from "office-ui-fabric-react/lib/Utilities";
import { Persona, PersonaSize } from "office-ui-fabric-react/lib/Persona";
import { TooltipHost, TooltipOverflowMode } from '../../Tooltip';
import { DefaultCardContactLine } from "./DefaultCard";
var DefaultAbridgedCard = /** @class */ (function (_super) {
    tslib_1.__extends(DefaultAbridgedCard, _super);
    function DefaultAbridgedCard() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    // Render
    DefaultAbridgedCard.prototype.render = function () {
        var _this = this;
        var mainPersonaData = {
            imageUrl: this.props.identity.image,
            primaryText: this.props.identity.displayName
        };
        var mainPersona = (React.createElement("div", null,
            React.createElement(Persona, tslib_1.__assign({}, mainPersonaData, { key: this.props.identity.entityId, size: PersonaSize.large, className: "persona-main", onRenderPrimaryText: function () {
                    return (React.createElement(TooltipHost, { key: _this.props.identity.entityId + ".primarytext.tooltip", content: mainPersonaData.primaryText, overflowMode: TooltipOverflowMode.Parent },
                        React.createElement("span", { className: "persona-main-text-primary" }, mainPersonaData.primaryText)));
                }, imageShouldFadeIn: false }))));
        return (React.createElement("div", { className: "default-card-abridged" },
            mainPersona,
            this._verifySignInAddress() && (React.createElement("div", null,
                React.createElement("div", { className: "default-card-contact-info-wrapper" },
                    React.createElement("hr", { className: "hr-main" }),
                    React.createElement("div", { className: "default-card-header-wrapper" },
                        React.createElement("span", { className: "default-card-header" },
                            React.createElement(Label, null,
                                React.createElement("b", { className: "default-card-header-space" }, Resources.PeoplePickerContact)))),
                    React.createElement("div", { className: "default-card-contact-info-container" },
                        React.createElement(DefaultCardContactLine, { iconName: "Mail", content: this.props.identity.signInAddress, link: "mailto:" + this.props.identity.signInAddress }),
                        React.createElement(DefaultCardContactLine, { iconName: "Chat", content: Resources.PeoplePickerStartChat, link: "sip:" + this.props.identity.signInAddress })))))));
    };
    DefaultAbridgedCard.prototype._verifySignInAddress = function () {
        if (!this.props.identity.signInAddress) {
            return false;
        }
        // this is copied from System.ComponentModel.DataAnnotations.EmailAddressAttribute
        var PROFILE_EMAIL_ADDRESS_PATTERN = /^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?$/i;
        if (PROFILE_EMAIL_ADDRESS_PATTERN.test(this.props.identity.signInAddress)) {
            return true;
        }
        return false;
    };
    return DefaultAbridgedCard;
}(BaseComponent));
export { DefaultAbridgedCard };
