import * as tslib_1 from "tslib";
import "../../FabricInit";
import * as React from "react";
import * as Resources from '../../VSS.Resources.VSSUI';
import { Label } from "office-ui-fabric-react/lib/Label";
import { BaseComponent } from "office-ui-fabric-react/lib/Utilities";
import { Persona, PersonaSize } from "office-ui-fabric-react/lib/Persona";
import { VssIcon } from '../../VssIcon';
import { TooltipHost, TooltipOverflowMode } from '../../Tooltip';
var DefaultCardContactLine = /** @class */ (function (_super) {
    tslib_1.__extends(DefaultCardContactLine, _super);
    function DefaultCardContactLine() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    // Render
    DefaultCardContactLine.prototype.render = function () {
        return (React.createElement("div", { className: "default-card-contact-line-wrapper" },
            React.createElement(Label, { className: "default-card-contact-line" },
                React.createElement(VssIcon, { iconName: this.props.iconName, className: "default-card-contact-line-label" }),
                this.props.link && (React.createElement("a", { href: this.props.link, className: "default-card-contact-line-link profile-card-tab-element" }, this.props.content)),
                !this.props.link && React.createElement("span", { className: "default-card-contact-line-no-link" }, this.props.content))));
    };
    return DefaultCardContactLine;
}(BaseComponent));
export { DefaultCardContactLine };
var DefaultCard = /** @class */ (function (_super) {
    tslib_1.__extends(DefaultCard, _super);
    function DefaultCard() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    // Setting the focus for the case of default card mounting when we come back via back header
    DefaultCard.prototype.componentDidMount = function () {
        if (this.props.setFocus) {
            this.props.setFocus();
        }
    };
    // Render
    DefaultCard.prototype.render = function () {
        var _this = this;
        var _a = this.props, identity = _a.identity, isPreviousHeader = _a.isPreviousHeader;
        var mainPersonaData = {
            imageUrl: this.props.identity.image,
            primaryText: this.props.identity.displayName,
            secondaryText: this.props.identity.jobTitle,
            tertiaryText: this.props.identity.department
        };
        var mainPersona = (React.createElement("div", null,
            React.createElement(Persona, tslib_1.__assign({}, mainPersonaData, { key: this.props.identity.entityId + this.props.identity.signInAddress, size: PersonaSize.large, className: "persona-main", onRenderPrimaryText: function () {
                    return (React.createElement(TooltipHost, { key: _this.props.identity.entityId + ".primarytext.tooltip", content: mainPersonaData.primaryText, overflowMode: TooltipOverflowMode.Parent },
                        React.createElement("span", { className: "persona-main-text-primary" }, mainPersonaData.primaryText)));
                }, onRenderSecondaryText: function () {
                    return (React.createElement(TooltipHost, { key: _this.props.identity.entityId + ".secondarytext.tooltip", content: mainPersonaData.secondaryText, overflowMode: TooltipOverflowMode.Parent },
                        React.createElement("span", { className: "persona-main-text-secondary" }, mainPersonaData.secondaryText)));
                }, onRenderTertiaryText: function () {
                    return React.createElement("div", { className: "persona-main-text-tertiary" }, mainPersonaData.tertiaryText);
                }, imageShouldFadeIn: false }))));
        var managerPersona = null;
        if (this.props.manager) {
            var adjacentManager_1 = this.props.manager;
            var adjacentManagerData_1 = {
                imageUrl: adjacentManager_1.image,
                primaryText: adjacentManager_1.displayName,
                secondaryText: adjacentManager_1.jobTitle,
                tertiaryText: adjacentManager_1.department
            };
            managerPersona = (React.createElement("div", { className: "persona-list-manager-element profile-card-tab-element", "aria-label": adjacentManager_1.displayName, key: adjacentManager_1.entityId + adjacentManager_1.signInAddress, onClick: function () {
                    _this.props.onClickEntity(adjacentManager_1);
                }, "data-is-focusable": true, role: "button" },
                React.createElement(Persona, tslib_1.__assign({}, adjacentManagerData_1, { size: PersonaSize.size40, onRenderPrimaryText: function () {
                        return React.createElement("div", { className: "persona-list-element-text-primary" }, adjacentManagerData_1.primaryText);
                    }, onRenderSecondaryText: function () {
                        return React.createElement("div", { className: "persona-list-element-text-secondary" }, adjacentManagerData_1.secondaryText);
                    }, imageShouldFadeIn: false }))));
        }
        return (React.createElement("div", { className: isPreviousHeader ? "default-card-with-header" : "default-card-without-header" },
            mainPersona,
            React.createElement("div", null,
                (identity.mail || identity.telephoneNumber || identity.physicalDeliveryOfficeName) && (React.createElement("div", { className: "default-card-contact-info-wrapper" },
                    React.createElement("hr", { className: "hr-main" }),
                    React.createElement("div", { className: "default-card-header-wrapper" },
                        React.createElement("span", { className: "default-card-header pointer profile-card-tab-element", onClick: function () {
                                _this.props.showContactCard();
                            }, "aria-label": Resources.PeoplePickerContact, "data-is-focusable": true, role: "button" },
                            React.createElement(Label, { className: "pointer" },
                                React.createElement("b", { className: "default-card-header-space" }, Resources.PeoplePickerContact),
                                React.createElement(VssIcon, { iconType: 0 /* fabric */, iconName: "ChevronRight" })))),
                    React.createElement("div", { className: "default-card-contact-info-container" },
                        identity.mail && React.createElement(DefaultCardContactLine, { iconName: "Mail", content: identity.mail, link: "mailto:" + identity.mail }),
                        identity.mail && (React.createElement(DefaultCardContactLine, { iconName: "Chat", content: Resources.PeoplePickerStartChat, link: "sip:" + identity.mail })),
                        identity.telephoneNumber && (React.createElement(DefaultCardContactLine, { iconName: "Phone", content: identity.telephoneNumber, link: "tel:" + identity.telephoneNumber })),
                        identity.physicalDeliveryOfficeName && (React.createElement(DefaultCardContactLine, { iconName: "POI", content: identity.physicalDeliveryOfficeName }))))),
                this._renderDirectManagerElement(managerPersona))));
    };
    /**
     * Renders the direct manager for the persona.
     * @param managerPersona The manager persona.
     */
    DefaultCard.prototype._renderDirectManagerElement = function (managerPersona) {
        var _this = this;
        if (!managerPersona) {
            return null;
        }
        return (React.createElement("div", { className: "default-card-direct-manager-wrapper" },
            React.createElement("hr", { className: "hr-secondary" }),
            React.createElement("div", { className: "default-card-header-wrapper" },
                React.createElement("span", { className: "default-card-header pointer profile-card-tab-element", onClick: function () {
                        _this.props.showOrganizationCard();
                    }, "aria-label": Resources.PeoplePickerOrganization, "data-is-focusable": true, role: "button" },
                    React.createElement(Label, { className: "pointer" },
                        React.createElement("b", { className: "default-card-header-space" }, Resources.PeoplePickerOrganization),
                        React.createElement(VssIcon, { iconType: 0 /* fabric */, iconName: "ChevronRight" })))),
            React.createElement("div", { className: "default-card-direct-manager" },
                React.createElement("div", { className: "default-card-header-reportsto" }, Resources.PeoplePickerReportsTo),
                managerPersona)));
    };
    return DefaultCard;
}(React.Component));
export { DefaultCard };
