import * as tslib_1 from "tslib";
import "../../FabricInit";
import * as React from "react";
import * as Resources from '../../VSS.Resources.VSSUI';
import { Label } from "office-ui-fabric-react/lib/Label";
import { BaseComponent, format } from "office-ui-fabric-react/lib/Utilities";
import { Persona, PersonaSize } from "office-ui-fabric-react/lib/Persona";
var OrganizationCard = /** @class */ (function (_super) {
    tslib_1.__extends(OrganizationCard, _super);
    function OrganizationCard() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    // Render
    OrganizationCard.prototype.render = function () {
        var managerPersonaList = this.createManagerChainPersonaElements();
        var directReportPersonaList = this.createDirectReportsPersonaElements();
        return (React.createElement("div", { className: "contact-or-organization-card-wrapper" },
            React.createElement("div", { className: "organization-card-content" },
                React.createElement("div", { className: "organization-card-header-wrapper" },
                    React.createElement(Label, null, Resources.PeoplePickerOrganization)),
                React.createElement("div", { className: "organization-card-manager-chain-wrapper" }, managerPersonaList),
                directReportPersonaList.length > 0 && (React.createElement("div", { className: "organization-card-direct-reports-wrapper" },
                    React.createElement(Label, { className: "organization-card-direct-reports-label" }, format(Resources.PeoplePickerReportingTo, this.props.identity.displayName, this.props.directReportList.length)),
                    directReportPersonaList)))));
    };
    // Helper methods to create Presona elements
    OrganizationCard.prototype.createManagerChainPersonaElements = function () {
        var _this = this;
        var self = this;
        var managerChainElementList = this.props.managerList
            ? this.props.managerList.map(function (manager) {
                var managerData = {
                    imageUrl: manager.image,
                    primaryText: manager.displayName ? manager.displayName : "",
                    secondaryText: manager.jobTitle ? manager.jobTitle : "",
                    tertiaryText: manager.department ? manager.department : ""
                };
                return (React.createElement("div", { className: "persona-list-element profile-card-tab-element", "aria-label": manager.displayName, key: manager.entityId + manager.signInAddress, onClick: function () {
                        self.props.onClickEntity(manager);
                    }, "data-is-focusable": true, role: "button" },
                    React.createElement(Persona, tslib_1.__assign({}, managerData, { size: PersonaSize.size40, onRenderPrimaryText: function () {
                            return React.createElement("div", { className: "persona-list-element-text-primary" }, managerData.primaryText);
                        }, onRenderSecondaryText: function () {
                            return React.createElement("div", { className: "persona-list-element-text-secondary" }, managerData.secondaryText);
                        }, imageShouldFadeIn: false }))));
            })
            : [];
        // Append current identity to list
        var mainPersonaData = {
            imageUrl: this.props.identity.image,
            primaryText: this.props.identity.displayName,
            secondaryText: this.props.identity.jobTitle,
            tertiaryText: this.props.identity.department
        };
        managerChainElementList.push(React.createElement("div", { className: "persona-list-element profile-card-tab-element", "aria-label": this.props.identity.displayName, key: this.props.identity.entityId + this.props.identity.signInAddress, onClick: function () {
                self.props.onClickEntity(_this.props.identity);
            }, "data-is-focusable": true, role: "button" },
            React.createElement(Persona, tslib_1.__assign({}, mainPersonaData, { size: PersonaSize.size40, onRenderPrimaryText: function () {
                    return React.createElement("div", { className: "persona-list-element-text-primary" }, mainPersonaData.primaryText);
                }, onRenderSecondaryText: function () {
                    return React.createElement("div", { className: "persona-list-element-text-secondary" }, mainPersonaData.secondaryText);
                }, imageShouldFadeIn: false }))));
        return managerChainElementList;
    };
    OrganizationCard.prototype.createDirectReportsPersonaElements = function () {
        var self = this;
        var directReportElementList = this.props.directReportList
            ? this.props.directReportList.map(function (directReport) {
                var directReportData = {
                    imageUrl: directReport.image,
                    primaryText: directReport.displayName ? directReport.displayName : "",
                    secondaryText: directReport.jobTitle ? directReport.jobTitle : "",
                    tertiaryText: directReport.department ? directReport.department : ""
                };
                return (React.createElement("div", { className: "persona-list-element profile-card-tab-element", "aria-label": directReport.displayName, key: directReport.entityId + directReport.signInAddress, onClick: function () {
                        self.props.onClickEntity(directReport);
                    }, "data-is-focusable": true, role: "button" },
                    React.createElement(Persona, tslib_1.__assign({}, directReportData, { size: PersonaSize.size40, onRenderPrimaryText: function () {
                            return React.createElement("div", { className: "persona-list-element-text-primary" }, directReportData.primaryText);
                        }, onRenderSecondaryText: function () {
                            return React.createElement("div", { className: "persona-list-element-text-secondary" }, directReportData.secondaryText);
                        }, imageShouldFadeIn: false }))));
            })
            : [];
        return directReportElementList;
    };
    return OrganizationCard;
}(BaseComponent));
export { OrganizationCard };
