import * as tslib_1 from "tslib";
import "../../FabricInit";
import * as React from "react";
import * as Resources from '../../VSS.Resources.VSSUI';
import { BaseComponent } from "office-ui-fabric-react/lib/Utilities";
import { TooltipHost, TooltipOverflowMode } from '../../Tooltip';
import { VssIcon } from '../../VssIcon';
import { Persona, PersonaSize } from "office-ui-fabric-react/lib/Persona";
var PersonaCardHeaderElement = /** @class */ (function (_super) {
    tslib_1.__extends(PersonaCardHeaderElement, _super);
    function PersonaCardHeaderElement() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PersonaCardHeaderElement.prototype.componentDidMount = function () {
        this.props.setFocus && this.props.setFocus();
    };
    PersonaCardHeaderElement.prototype.componentDidUpdate = function () {
        this.props.setFocus && this.props.setFocus();
    };
    // Render
    PersonaCardHeaderElement.prototype.render = function () {
        var _this = this;
        if (!this.props.identity) {
            // Identity is null in the case of previous
            return null;
        }
        var identity = this.props.identity;
        var personaData = {
            imageUrl: identity.image,
            primaryText: identity.displayName,
            secondaryText: identity.jobTitle,
            tertiaryText: identity.department
        };
        return (React.createElement("div", { className: "go-back-persona-wrapper", onClick: this.props.onClickFunction, "aria-label": Resources.PeoplePickerHeaderButtonLabel, ref: function (element) {
                _this._personaElement = element;
            }, "data-is-focusable": true, role: "button" },
            React.createElement("div", null,
                React.createElement(VssIcon, { iconType: 0 /* fabric */, iconName: "ChevronLeft" })),
            React.createElement("div", { className: "go-back-positioning" },
                React.createElement(Persona, tslib_1.__assign({}, personaData, { size: PersonaSize.extraExtraSmall, className: "go-back-persona", onRenderPrimaryText: function () {
                        return (React.createElement(TooltipHost, { key: identity.entityId + ".tooltip", content: identity.displayName, overflowMode: TooltipOverflowMode.Parent },
                            React.createElement("span", { className: "persona-header-text-primary" }, identity.displayName)));
                    }, imageShouldFadeIn: false })))));
    };
    /**
     * Sets the focus on this header.
     */
    PersonaCardHeaderElement.prototype.setFocus = function () {
        if (this._personaElement) {
            this._personaElement.focus();
        }
    };
    return PersonaCardHeaderElement;
}(BaseComponent));
export { PersonaCardHeaderElement };
