import "../../FabricInit";
import * as React from 'react';
import { BaseComponent } from 'office-ui-fabric-react/lib/Utilities';
import { IBreakPoint, IResponsiveViewportProps, IResponsiveViewport } from '../../Components/ResponsiveViewport/ResponsiveViewport.Props';
export interface IResponsiveWrapperState<T extends IBreakPoint = IBreakPoint> {
    /** Currently active breakpoints */
    activeBreakpoints: T[];
}
export declare class ResponsiveViewport<T extends IBreakPoint = IBreakPoint> extends BaseComponent<IResponsiveViewportProps<T>, IResponsiveWrapperState<T>> implements IResponsiveViewport {
    private _element;
    constructor(props: IResponsiveViewportProps<T>);
    componentDidMount(): void;
    componentWillUnmount(): void;
    shouldComponentUpdate(newProps: IResponsiveViewportProps<T>, newState: IResponsiveWrapperState<T>): boolean;
    render(): React.DetailedReactHTMLElement<{
        className: string;
        ref: (element: HTMLElement) => void;
    }, HTMLElement>;
    measure(): void;
    private _onAsyncResize;
    private _resize;
    private _getActiveBreakpoints;
    private _resolveElement;
}
