import * as tslib_1 from "tslib";
import "../../FabricInit";
import "../../Core/core.scss";
import "../../Common.scss";
import "./StackPanel.scss";
import * as React from "react";
import { BaseComponent, css } from 'office-ui-fabric-react/lib/Utilities';
import { IconButton } from 'office-ui-fabric-react/lib/Button';
var backIconProps = { iconName: "ChevronLeft", className: "vss-StackPanel-BackIcon" };
var StackPanel = /** @class */ (function (_super) {
    tslib_1.__extends(StackPanel, _super);
    function StackPanel(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            stack: props.initialStack || []
        };
        return _this;
    }
    StackPanel.prototype.render = function () {
        var stack = this.state.stack;
        var topElement = this.peek();
        return React.createElement("div", { className: css("vss-StackPanel flex-column", this.props.className) },
            topElement.title && React.createElement("div", { className: "vss-StackPanel-Header flex-row" },
                stack.length > 1 && React.createElement(IconButton, { onClick: this.pop.bind(this), className: "vss-StackPanel-BackButton", iconProps: backIconProps }),
                React.createElement("div", { className: "vss-StackPanel-Title title-xs" }, topElement && topElement.title)),
            topElement && topElement.renderContent && topElement.renderContent());
    };
    StackPanel.prototype.push = function (item) {
        var stack = this.state.stack;
        stack.push(item);
        this.setState({
            stack: stack
        });
    };
    StackPanel.prototype.pop = function () {
        var stack = this.state.stack;
        var poppedItem = stack.pop();
        this.setState({
            stack: stack
        });
        return poppedItem;
    };
    StackPanel.prototype.peek = function () {
        return this.state.stack[this.state.stack.length - 1];
    };
    return StackPanel;
}(BaseComponent));
export { StackPanel };
