import * as tslib_1 from "tslib";
import * as React from "react";
import { Tabs } from "./Tabs";
import { TabProviderContext } from "./TabProviderContext";
import { Tab } from "./Tab";
import { css } from '../../Util';
/**
 * Renders tabs (provided as children or through a tab provider context) as well as addtional
 * content such as in-line filters, view options, etc.
 *
 * Tabs provided directly as children will always be place before contributed tabs.
 */
var TabBar = /** @class */ (function (_super) {
    tslib_1.__extends(TabBar, _super);
    function TabBar() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onRenderAdditionalContent = function (renderFilterBar) {
            if (renderFilterBar) {
                return renderFilterBar(true);
            }
            return _this.props.onRenderAdditionalContent && _this.props.onRenderAdditionalContent();
        };
        _this.createTab = function (tab) {
            return React.createElement(Tab, { key: tab.id, id: tab.id, name: tab.name, url: tab.url, onBeforeTabChange: tab.onBeforeTabChange });
        };
        return _this;
    }
    TabBar.prototype.render = function () {
        var _this = this;
        return (React.createElement(TabProviderContext.Consumer, null, function (tabProviderContext) {
            var selectedTabId = _this.props.selectedTabId || (tabProviderContext.selectedId);
            return React.createElement("div", { className: css("vss-TabBar flex-row flex-center flex-noshrink", _this.props.className, !_this.props.disableSticky && "sticky") },
                React.createElement(Tabs, tslib_1.__assign({ onSelectedTabChanged: tabProviderContext.onSelectedTabChanged, selectedTabId: selectedTabId }, _this.props, { className: "flex-grow" }),
                    _this.props.children,
                    tabProviderContext.tabs.map(_this.createTab)),
                _this.onRenderAdditionalContent(tabProviderContext.renderFilterBar));
        }));
    };
    return TabBar;
}(React.Component));
export { TabBar };
