import * as tslib_1 from "tslib";
import * as React from "react";
import { TabProviderContext } from "./TabProviderContext";
/**
 * Hooks into tab provider context to render the tab's provided content, as well
 * as optionally the a filter bar if it is to be rendered outside of the TabBar.
 */
var TabContent = /** @class */ (function (_super) {
    tslib_1.__extends(TabContent, _super);
    function TabContent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TabContent.prototype.render = function () {
        var _this = this;
        return React.createElement(TabProviderContext.Consumer, null, function (tabProviderContext) {
            if (tabProviderContext.renderContent) {
                var filterBar = tabProviderContext.renderFilterBar && tabProviderContext.renderFilterBar(false);
                return React.createElement(React.Fragment, null,
                    filterBar,
                    tabProviderContext.renderContent());
            }
            return React.createElement(React.Fragment, null, _this.props.children);
        });
    };
    return TabContent;
}(React.Component));
export { TabContent };
