/// <reference types="react" />
import "../../FabricInit";
import { ITreeProps, ITree, ITreeListItem } from "../../Components/Tree/Tree.Props";
import { BaseComponent } from "office-ui-fabric-react/lib/Utilities";
import { IColumn } from "office-ui-fabric-react/lib/DetailsList";
export interface ITreeState<T> {
    treeListItems: ITreeListItem<T>[];
    treeListItemColumns: IColumn[];
}
export declare class Tree<T> extends BaseComponent<ITreeProps<T>, ITreeState<T>> implements ITree<T> {
    private treeList;
    private childrenMap;
    constructor(props: ITreeProps<T>);
    setSelectedItemsById(selectedItemIds: string[] | undefined): void;
    componentWillReceiveProps(newProps: ITreeProps<T>): void;
    render(): JSX.Element;
    private buildColumns;
    private buildTree;
    private addTreeItems;
    private getOrCreateTreeListItem;
    private onItemToggled;
}
