import { ITreeItem, ITreeListItem, ITreeItemProvider } from "../../Components/Tree/Tree.Props";
export declare abstract class TreeItemProvider<T> implements ITreeItemProvider<T> {
    private treeListItemMap;
    constructor();
    abstract getChildren(item: T | undefined): T[] | Promise<T[]>;
    abstract getTreeItem(item: T): ITreeItem<T>;
    setTreeListItem(item: T, treeListItem: ITreeListItem<T>): void;
    getTreeListItem(item: T): ITreeListItem<T>;
}
