/// <reference types="react" />
import "../../FabricInit";
import { BaseComponent } from "office-ui-fabric-react/lib/Utilities";
import { IVssBreadcrumb, IVssBreadcrumbPickList, IVssBreadcrumbProps, IVssBreadcrumbItem } from "../../Components/VssBreadcrumb/VssBreadcrumb.Props";
import "./VssBreadcrumb.css";
export interface IPickerDropdownState {
    calloutIsVisible: boolean;
}
export interface IVssBreadcrumbState {
    pickerIsOpen: boolean;
    pickerItemKey: string | null;
    loadingTimeoutId?: number;
    displayItems: IVssBreadcrumbItem[];
}
export declare class VssBreadcrumb extends BaseComponent<IVssBreadcrumbProps, IVssBreadcrumbState> implements IVssBreadcrumb {
    private _pinElements;
    private _linkElements;
    private _linkItems;
    private _focusedLinkIndex;
    private _isMounted;
    private _contributedItems;
    pickList: IVssBreadcrumbPickList;
    static defaultProps: IVssBreadcrumbProps;
    constructor(props: IVssBreadcrumbProps);
    componentWillReceiveProps(newProps: IVssBreadcrumbProps): void;
    componentDidMount(): void;
    private _updateLinkItems;
    private _setLoadingTimeout;
    private _loadItemsFromProviders;
    componentWillUnmount(): void;
    private _getIcon;
    private _onItemClick;
    private onRenderItem;
    private _onLinkFocus;
    private _renderPickerDropdown;
    private _getBreadcrumbIcon;
    private _getCustomDivider;
    private _getDividerButtonOrIcon;
    private _getIndicators;
    private _onKeyDown;
    private _onBlur;
    private _itemsChanged;
    /**
     * Sort our breadcrumb items
     * @param items
     */
    private _arrangeItems;
    render(): JSX.Element;
}
