import * as tslib_1 from "tslib";
import "../../FabricInit";
import * as React from 'react';
import { Icon, IconType } from 'office-ui-fabric-react/lib/Icon';
import { BaseComponent, css } from 'office-ui-fabric-react/lib/Utilities';
import "./VssIcon.css";
var VssIcon = /** @class */ (function (_super) {
    tslib_1.__extends(VssIcon, _super);
    function VssIcon(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {};
        return _this;
    }
    VssIcon.prototype.render = function () {
        return (React.createElement(Icon, tslib_1.__assign({}, VssIcon.getIconProps(this.props)), this.props.children));
    };
    /**
     * Convert IVssIconProps to Fabric's IIconProps. To use with components such as IconButton
     * that take IIconProps. This is a pure function.
     * @param props
     * @param className Additional CSS class name to apply to the returned icon
     * @return
     */
    VssIcon.getIconProps = function (props, className) {
        var fabricIconProps = tslib_1.__assign({}, props);
        delete fabricIconProps.iconType;
        delete fabricIconProps.iconName;
        // If IconType is not specified, but the iconName includes the "bowtie-", then set icon type to bowtie.
        var passedIconType = props.iconType;
        if (!passedIconType && props.iconName && props.iconName.substr(0, VssIcon.bowtieIconPrefix.length) === VssIcon.bowtieIconPrefix) {
            passedIconType = 1 /* bowtie */;
        }
        // IconType is either image or default.
        fabricIconProps.iconType = props.iconType === 3 /* image */ ? IconType.image : IconType.default;
        var vssIconClass = css("vss-Icon", className);
        if (fabricIconProps.className) {
            fabricIconProps.className = fabricIconProps.className + " " + vssIconClass;
        }
        else {
            fabricIconProps.className = vssIconClass;
        }
        if (passedIconType === 1 /* bowtie */) {
            var iconName = props.iconName;
            if (typeof iconName === "string" && iconName.substr(0, VssIcon.bowtieIconPrefix.length) !== VssIcon.bowtieIconPrefix) {
                iconName = VssIcon.bowtieIconPrefix + iconName;
            }
            var newClasses = css("vss-Icon--bowtie", iconName);
            fabricIconProps.className = fabricIconProps.className + " " + newClasses;
        }
        else {
            fabricIconProps.iconName = props.iconName;
        }
        return fabricIconProps;
    };
    VssIcon.bowtieIconPrefix = "bowtie-";
    return VssIcon;
}(BaseComponent));
export { VssIcon };
