import * as React from 'react';
/**
 * Gets the children of the specified type (includes child index as well).
 *
 * @param props Container props including children.
 * @param type Type of the children.
 */
export function childrenOfType(children, type) {
    var found = [];
    React.Children.map(children || [], function (item, index) {
        if (typeof item === 'object' && item.type === type) {
            found.push({ index: index, item: item });
        }
    });
    return found;
}
